package net.horizoncode.nekorip.template;

import com.google.common.collect.Maps;
import freemarker.template.Template;
import net.horizoncode.nekorip.NekoRIP;
import spark.Request;
import spark.Response;
import spark.Route;

import java.io.StringWriter;
import java.io.Writer;
import java.util.concurrent.ConcurrentMap;

/**
 * Created by HorizonCode at 10/05/2021
 *
 * @author HorizonCode
 * @since 10/05/2021
 **/
public class BaseTemplateRoute implements Route {

    private final String templateName;

    public BaseTemplateRoute(String templateName) {
        this.templateName = templateName;
    }

    @Override
    public Object handle(Request request, Response response) throws Exception {
        ConcurrentMap<Object, Object> placeHolderList = Maps.newConcurrentMap();
        Template template = NekoRIP.getInstance().getTemplates().getTemplate(templateName);
        Writer compiledTemplate = new StringWriter();
        template.process(placeHolderList, compiledTemplate);
        return compiledTemplate.toString();
    }
}
